/*
 * 文 件 名:  ClassTailor.java
 * 版    权:   . Copyright 2008-2017,  All rights reserved   Co.,Ltd.
 * 描    述:  <描述>
 * 修 改 人:  simon
 * 修改时间:  2018年4月20日
 */
package com.cnblogs.simoncook.jaxb.helper;

import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.security.AccessController;
import java.security.PrivilegedAction;

import com.cnblogs.simoncook.jaxb.bean.User;

/**
 * <一句话功能简述> <功能详细描述>
 * 
 * @author simon
 * @version [版本号, 2018年4月20日]
 * @see [相关类/方法]
 * @since [产品/模块版本]
 */
public class ClassTailor
{
    
    /**
     * <一句话功能简述> <功能详细描述>
     * 
     * @param args
     * @see [类、类#方法、类#成员]
     */
    public static void main(String[] args)
    {
        User u = new User();
        ClassLoader classLoader = ClassTailor.class.getClassLoader();
        String templateClassName = "com/cnblogs/simoncook/jaxb/helper/MethodAcessTemplate";
        String methodAcessRefTemplate = templateClassName + ".class";
        InputStream templateClassResource = classLoader.getResourceAsStream(methodAcessRefTemplate);
        String[] replacements = {"com/cnblogs/simoncook/jaxb/helper/Bean", "com/cnblogs/simoncook/jaxb/bean/User",
            "com/cnblogs/simoncook/jaxb/helper/Ref", "java/lang/String", "()Lcom/cnblogs/simoncook/jaxb/helper/Ref;",
            "()Ljava/lang/String;", "(Lcom/cnblogs/simoncook/jaxb/helper/Ref;)V", "(Ljava/lang/String;)V", "getRef",
            "getName", "setRef", "setName"};
        
        String newClassName = "com/cnblogs/simoncook/jaxb/bean/User_getset_name";
        byte[] accessClassByte = tailor(templateClassResource, templateClassName, newClassName, replacements);
        dumpClass(newClassName, accessClassByte);
        
        try
        {
            @SuppressWarnings("unchecked")
            Class<IMethodAccess> c = buildGetSetClass(classLoader, newClassName, accessClassByte);
            IMethodAccess accessor = (IMethodAccess)c.newInstance();
            accessor.set(u, "simon");
            System.out.println(u.getName());
        }
        catch (NoSuchMethodException e)
        {
            e.printStackTrace();
        }
        catch (SecurityException e)
        {
            e.printStackTrace();
        }
        catch (IllegalAccessException e)
        {
            e.printStackTrace();
        }
        catch (IllegalArgumentException e)
        {
            e.printStackTrace();
        }
        catch (InvocationTargetException e)
        {
            e.printStackTrace();
        }
        catch (InstantiationException e)
        {
            e.printStackTrace();
        }
        
    }
    
    /**
     * <一句话功能简述> <功能详细描述>
     * 
     * @param classLoader
     * @param newClassName
     * @param accessClassByte
     * @return
     * @throws NoSuchMethodException
     * @throws IllegalAccessException
     * @throws InvocationTargetException
     * @see [类、类#方法、类#成员]
     */
    private static Class<IMethodAccess> buildGetSetClass(ClassLoader classLoader, String newClassName,
        byte[] accessClassByte)
        throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    {
        final Method defineClass =
            ClassLoader.class.getDeclaredMethod("defineClass", String.class, byte[].class, Integer.TYPE, Integer.TYPE);
        final Method resolveClass = ClassLoader.class.getDeclaredMethod("resolveClass", Class.class);
        AccessController.doPrivileged(new PrivilegedAction<Void>()
        {
            
            public Void run()
            {
                // TODO: check security implication
                // do these setAccessible allow anyone to call these methods freely?s
                defineClass.setAccessible(true);
                resolveClass.setAccessible(true);
                return null;
            }
        });
        ClassLoader filedTypeClassLoader = classLoader;
        
        @SuppressWarnings("unchecked")
        Class<IMethodAccess> c = (Class<IMethodAccess>)defineClass.invoke(filedTypeClassLoader,
            newClassName.replace('/', '.'),
            accessClassByte,
            0,
            accessClassByte.length);
        resolveClass.invoke(filedTypeClassLoader, c);
        return c;
    }
    
    /**
     * <一句话功能简述> <功能详细描述>
     * 
     * @param newClassName
     * @param accessClassByte
     * @see [类、类#方法、类#成员]
     */
    private static void dumpClass(String newClassName, byte[] accessClassByte)
    {
        FileOutputStream out = null;
        BufferedOutputStream bufW = null;
        try
        {
            File file = new File("/Users/simon/700.temp_/jaxbclass/" + newClassName);
            if (!file.getParentFile().exists())
            {
                file.getParentFile().mkdirs();
            }
            out = new FileOutputStream(file);
            bufW = new BufferedOutputStream(out);
            bufW.write(accessClassByte);
            bufW.flush();
            bufW.close();
        }
        catch (FileNotFoundException e)
        {
            e.printStackTrace();
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        finally
        {
            if (out != null)
            {
                try
                {
                    out.close();
                }
                catch (IOException e)
                {
                    e.printStackTrace();
                }
            }
            if (bufW != null)
            {
                try
                {
                    bufW.close();
                }
                catch (IOException e)
                {
                    e.printStackTrace();
                }
            }
        }
    }
    
    public static byte[] tailor(InputStream image, String templateClassName, String newClassName,
        String... replacements)
    {
        DataInputStream in = new DataInputStream(image);
        
        try
        {
            ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
            DataOutputStream out = new DataOutputStream(baos);
            
            // skip until the constant pool count
            long l = in.readLong();
            out.writeLong(l);
            
            // read the constant pool size
            short count = in.readShort();
            out.writeShort(count);
            
            // replace constant pools
            for (int i = 0; i < count; i++)
            {
                byte tag = in.readByte();
                out.writeByte(tag);
                switch (tag)
                {
                    case 0:
                        // this isn't described in the spec,
                        // but class files often seem to have this '0' tag.
                        // we can apparently just ignore it, but not sure
                        // what this really means.
                        break;
                    
                    case 1: // CONSTANT_UTF8
                    {
                        String value = in.readUTF();
                        if (value.equals(templateClassName))
                            value = newClassName;
                        else
                        {
                            for (int j = 0; j < replacements.length; j += 2)
                                if (value.equals(replacements[j]))
                                {
                                    value = replacements[j + 1];
                                    break;
                                }
                        }
                        out.writeUTF(value);
                    }
                        break;
                    
                    case 3: // CONSTANT_Integer
                    case 4: // CONSTANT_Float
                        out.writeInt(in.readInt());
                        break;
                    
                    case 5: // CONSTANT_Long
                    case 6: // CONSTANT_Double
                        i++; // doubles and longs take two entries
                        out.writeLong(in.readLong());
                        break;
                    
                    case 7: // CONSTANT_Class
                    case 8: // CONSTANT_String
                        out.writeShort(in.readShort());
                        break;
                    
                    case 9: // CONSTANT_Fieldref
                    case 10: // CONSTANT_Methodref
                    case 11: // CONSTANT_InterfaceMethodref
                    case 12: // CONSTANT_NameAndType
                        out.writeInt(in.readInt());
                        break;
                    
                    default:
                        throw new IllegalArgumentException("Unknown constant type " + tag);
                }
            }
            
            // then copy the rest
            byte[] buf = new byte[512];
            int len;
            while ((len = in.read(buf)) > 0)
                out.write(buf, 0, len);
            
            in.close();
            out.close();
            
            // by now we got the properly tailored class file image
            return baos.toByteArray();
        }
        catch (Exception e)
        {
        }
        return null;
    }
    
}
